import { Request, Middleware } from ".";
export declare type GetToken<Req> = (request: Req) => void | null | string;
/**
 * Adds the Authorization header with the returned string as the header value.
 * Won't set the Authorization token if the result from getToken is falsey.
 */
export declare function withAuthorization<CustomRequestOptions extends object = any>(getToken: GetToken<Request<any, CustomRequestOptions>>, prefix?: string): Middleware<Request<any, CustomRequestOptions>, any>;
/**
 * Adds the Authorization header with the returned string as the bearer token.
 * Won't set the Authorization token if the result from getToken is falsey.
 */
export declare function withBearer<CustomRequestOptions extends object = any>(getToken: GetToken<Request<any, CustomRequestOptions>>): Middleware<Request<any, CustomRequestOptions>, any>;
